/**
 * Copyright (c) 2020 Eclipse contributors and others.
 *
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.justj.codegen.model;


import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EObject;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Annotation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An annotation identified by its source, typically {@link org.eclipse.justj.codegen.model.util.ModelUtil#MODEL_PROPERTIES_ANNOTATION_URI Properties}, containing key-value pair details.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.justj.codegen.model.Annotation#getSource <em>Source</em>}</li>
 *   <li>{@link org.eclipse.justj.codegen.model.Annotation#getDetails <em>Details</em>}</li>
 * </ul>
 *
 * @see org.eclipse.justj.codegen.model.ModelPackage#getAnnotation()
 * @model
 * @generated
 */
public interface Annotation extends EObject
{
  /**
   * Returns the value of the '<em><b>Source</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The source identifier, e.g., https://www.eclipse.org/Annotation, typically {@link org.eclipse.justj.codegen.model.util.ModelUtil#MODEL_PROPERTIES_ANNOTATION_URI Properties} identifying the meaning of the key-value pair details.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Source</em>' attribute.
   * @see #setSource(String)
   * @see org.eclipse.justj.codegen.model.ModelPackage#getAnnotation_Source()
   * @model
   * @generated
   */
  String getSource();

  /**
   * Sets the value of the '{@link org.eclipse.justj.codegen.model.Annotation#getSource <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' attribute.
   * @see #getSource()
   * @generated
   */
  void setSource(String value);

  /**
   * Returns the value of the '<em><b>Details</b></em>' map.
   * The key is of type {@link java.lang.String},
   * and the value is of type {@link java.lang.String},
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The arbitrary key-value pairs of the annotation.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Details</em>' map.
   * @see org.eclipse.justj.codegen.model.ModelPackage#getAnnotation_Details()
   * @model mapType="org.eclipse.justj.codegen.model.Detail&lt;org.eclipse.emf.ecore.EString, org.eclipse.emf.ecore.EString&gt;"
   *        extendedMetaData="name='detail' kind='element'"
   * @generated
   */
  EMap<String, String> getDetails();

} // Annotation
